package br.edu.fei.dcc.raciocinioespacial.editor.commands;

import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchWindow;

public class Utils {

	private static int iFileCount = 1;
	
	public static int getFileCount()
	{
		int iRet = iFileCount;
		iFileCount++;
		return iRet;
	}
	
	public static String openFileDialog(IWorkbenchWindow workbenchWindow, String titulo, String extensao, int style) {
		return Utils.openFileDialog(workbenchWindow.getShell(), titulo, extensao, style);
	}
	
	public static String openFileDialog(Shell shell, String titulo, String extensao, int style) {
		FileDialog dialog = new FileDialog(shell, style);
		dialog.setText(titulo);
		dialog.setFilterExtensions(new String[] { extensao });
		return dialog.open();
	}
}
