package br.edu.fei.dcc.raciocinioespacial.editor.shapes.actions;

import org.eclipse.gef.requests.CreationFactory;

import br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements.Mobile2DShape;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements.Ponto2DShape;

public class NewPointCreationFactory implements CreationFactory {

	private Mobile2DShape parent;
	
	public NewPointCreationFactory(Mobile2DShape parent)
	{
		this.parent = parent;
	}
	
	public Object getNewObject() {
		Ponto2DShape retorno = new Ponto2DShape();
		retorno.setParent(this.parent);
		this.parent.getPoints().add(retorno);
		return retorno;
	}

	public Object getObjectType() {
		return Ponto2DShape.class;
	}

}
