package br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties;

import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.validators.FloatValidator;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.validators.FloatVelocityValidator;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.validators.IntegerValidator;

public class NumericProperty extends TextPropertyDescriptor {

	public NumericProperty(Object id, String displayName, NumericPropertyTypeEnum tipo) {
		super(id, displayName);
		if(tipo.equals(NumericPropertyTypeEnum.Integer))
			super.setValidator(new IntegerValidator());
		else if(tipo.equals(NumericPropertyTypeEnum.Float))
			super.setValidator(new FloatValidator());
		else if(tipo.equals(NumericPropertyTypeEnum.FloatVelociry))
			super.setValidator(new FloatVelocityValidator());
	}	
}