package br.edu.fei.dcc.raciocinioespacial.simulador.entidades;

import java.util.ArrayList;
import java.util.List;

public class Entidade2D {
	@SuppressWarnings("unchecked")
	public static <T extends IEntidade2D> T getMenorX(ArrayList<T> entidades)
	{
		T retorno = null;
		if(entidades!=null)
		{
			for(IEntidade2D e : entidades)
			{
				if(retorno==null)
				{
					retorno = (T)e;
				}else if((e.getX()-e.getWidth())<(retorno.getX()-retorno.getWidth()))
				{
					retorno = (T)e;
				}
			}
		}
		return retorno;
	}
	
	@SuppressWarnings("unchecked")
	public static <T extends IEntidade2D> T getMaiorX(ArrayList<T> entidades)
	{
		T retorno = null;
		if(entidades!=null)
		{
			for(IEntidade2D e : entidades)
			{
				if(retorno==null)
				{
					retorno = (T)e;
				}else if((e.getX()+e.getWidth())>(retorno.getX()+retorno.getWidth()))
				{
					retorno = (T)e;
				}
			}
		}
		return retorno;
	}
	
	@SuppressWarnings("unchecked")
	public static <T extends IEntidade2D> T getMenorY(ArrayList<T> entidades)
	{
		T retorno = null;
		if(entidades!=null)
		{
			for(IEntidade2D e : entidades)
			{
				if(retorno==null)
				{
					retorno = (T)e;
				}else if((e.getY()-e.getHeight())<(retorno.getY()-retorno.getHeight()))
				{
					retorno = (T)e;
				}
			}
		}
		return retorno;
	}
	
	@SuppressWarnings("unchecked")
	public static <T extends IEntidade2D> T getMaiorY(ArrayList<T> entidades)
	{
		T retorno = null;
		if(entidades!=null)
		{
			for(IEntidade2D e : entidades)
			{
				if(retorno==null)
				{
					retorno = (T)e;
				}else if((e.getY()+e.getHeight())>(retorno.getY()+retorno.getHeight()))
				{
					retorno = (T)e;
				}
			}
		}
		return retorno;
	}
	
	public static <T extends IEntidade2D> T getObjetoComMaiorPercurso(ArrayList<T> entidades)
	{
		T retorno = null;
		if(entidades!=null)
		{// TODO quem usa isso aqui!
			/*for(T obj : entidades)
			{
				if(retorno==null)
				{
					retorno = obj;
				}else if(obj.getTamanhoPercurso()>retorno.getTamanhoPercurso())
				{
					retorno = obj;
				}
			}*/
		}
		return retorno;
	}
	
	public static ArrayList<IEntidade2D> entidadeMovelToEntidade2D(List<IEntidadeMovel> entidades)
	{
		if(entidades!=null)
		{
			ArrayList<IEntidade2D> retorno = new ArrayList<IEntidade2D>();
			for(IEntidadeMovel m : entidades)
			{
				retorno.add((IEntidade2D)m);
			}
			return retorno;
		}
		return null;
	}
	
	public static long getMaiorTempo(ArrayList<IEntidade2D> entidades)
	{
		//IEntidadeMovel max = getObjetoComMaiorTempo(entidades);
		//return (long)(max.getTamanhoPercurso() / max.getVelocidade());
		return (long)(10); // TODO Mudar assim q possivel, pois pode estar zuando o perfil!
	}
	
	public static <T extends IEntidade2D> T getObjetoComMaiorTempo(ArrayList<T> entidades)
	{
		T retorno = null;
		/*if(entidades!=null)
		{// TODO Rever!
			for(T obj : entidades)
			{
				if(retorno==null)
				{
					retorno = obj;
				}else if(obj.getTamanhoPercurso()/obj.getVelocidade()>retorno.getTamanhoPercurso()/retorno.getVelocidade())
				{
					retorno = obj;
				}
			}
		}*/
		return retorno;
	}
	
	@SuppressWarnings("unchecked")
	public static ArrayList<IEntidade2D> definirInstante(ArrayList<IEntidade2D> entidades, float t)
	{
		if(entidades!=null)
		{
			// TODO Serve para colisoes.... ja era!
			/*ArrayList<IEntidade2D> retorno = (ArrayList<IEntidade2D>)entidades;//.clone();
			for(IEntidade2D e : retorno)
			{
				e.setInstanteAtual(t);
			}
			return retorno;*/
		}
		return null;
	}

	public static IEntidade2D getEntidadeMaisVeloz(IEntidade2D[] conjunto) {
		if((conjunto!=null)&&(conjunto.length>0))
		{
			IEntidade2D retorno = conjunto[0];
			for(IEntidade2D e : conjunto)
			{
				if(e.getVelocidade()>retorno.getVelocidade())
					retorno = e;
			}
			return retorno;
		}
		return null;
	}

	public static IEntidade2D getEntidadeMaisVeloz(IEntidade2D[] conjunto, float instanteAtual) {
		// TODO Pra que q serve isso daqui!
		if((conjunto!=null)&&(conjunto.length>0))
		{
			IEntidade2D retorno = conjunto[0];
			for(IEntidade2D e : conjunto)
			{
				if(e.getVelocidade()>retorno.getVelocidade())
					retorno = e;
			}
			return retorno;
		}
		return null;
	}
	
}
