package br.edu.fei.dcc.raciocinioespacial.simulador.util;

import java.awt.geom.Line2D;

public class Reta2D extends Line2D.Float {

	private static final long serialVersionUID = 1L;
	
	public Reta2D(int x1, int y1, int x2, int y2)
	{
		super(x1, y1, x2, y2);
	}
	
	public float getCoeficienteAngular()
	{
		float m = 0;
		if((this.x2-this.x1)!=0)
			m = (this.y2-this.y1)/(this.x2-this.x1);
		return m;
	}
	
	public float getCoeficienteLinear()
	{
		float b = 0;
		if(this.x1!=this.x2)
			b = this.y2-this.getCoeficienteAngular()*this.x2;
		return b;
	}
}