/**
 * 
 */
package br.edu.fei.dcc.raciocinioespacial.simulador.execucao;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

import br.edu.fei.dcc.raciocinioespacial.simulador.simulacao.Simulacao;

/**
 * @author Thiago
 *
 */
public class DlgDepthProfile extends JDialog  {
	@Override
	public void paint(Graphics g) {
		super.paint(g);
		if((this.simulacao.getContextProfile()==null)||(!this.simulacao.getContextProfile().equals(this.getGraphics())))
		{
			this.simulacao.setContextProfile(this.getGraphics());
		}
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Simulacao simulacao;
	private Dimension tamanhoTela;
	private JPanel espaco;

	/**
	 * This is the xxx default constructor
	 */
	public DlgDepthProfile(JFrame Owner, Simulacao simulacao, Dimension tamanhoTela) {
		super(Owner, "Depth Profile", ModalityType.MODELESS);
		this.simulacao = simulacao;
		this.tamanhoTela = tamanhoTela;
		this.init();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public void init() {
		this.setSize(this.getTamanhoTela());
		this.setContentPane(this.getEspaco());
		this.setTitle("Depth Profile");
	}


	public Simulacao getSimulacao() {
		return simulacao;
	}

	public void setSimulacao(Simulacao simulacao) {
		this.simulacao = simulacao;
	}

	public Dimension getTamanhoTela() {
		return tamanhoTela;
	}

	public void setTamanhoTela(Dimension tamanhoTela) {
		this.tamanhoTela = tamanhoTela;
	}

	public JPanel getEspaco() {
		if (this.espaco == null) {
			this.espaco = new JPanel();
			this.espaco.setLayout(new BorderLayout());
			//this.espaco.setBackground(Color.WHITE);
		}
		return this.espaco;
	}

	public void setEspaco(JPanel conteudo) {
		this.espaco = conteudo;
	}
}
