package br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.validators;

import org.eclipse.jface.viewers.ICellEditorValidator;

public class IntegerValidator implements ICellEditorValidator {

	public String isValid(Object value) {
		int intValue = -1;
		try { 
			intValue = Integer.parseInt((String) value);
		} catch (NumberFormatException exc) {
			return "No  um nmero";
		}
		return (intValue >= 0) ? null : "O valor precisa ser maior que 0.";
	}
}