/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package br.edu.fei.dcc.raciocinioespacial.simulador.prologCommunication;

/**
 * This class is a singleton.
 * It is used to hold the responses from prolog and make it visible to any other object.
 * @author João
 */


class PrologResponseHolder 
{    

    private static PrologResponseHolder instance = null;
    //This String will hold the response of the prolog
    private String prologResponse;
    //This will hold the counter returned by the prolog
    private long prologCounter;
    
    
    private PrologResponseHolder()
    {}
    
    public static PrologResponseHolder getInstance()
    {   
        if (instance == null)
        {instance = new PrologResponseHolder();}
        return instance;
    }    

    public long getPrologCounter() {
        return prologCounter;
    }

    public String getPrologResponse() {
        return prologResponse;
    }

    public void setPrologCounter(long prologCounter) {
        this.prologCounter = prologCounter;
    }

    public void setPrologResponse(String prologResponse) {
        this.prologResponse = prologResponse;
    }
    
	//This method is used to parse the response from prolog, spliting it in the number of the request and the response itself
    private void setPrologCounterAndResponse(String untreatedResponse)
    {
  
        this.prologCounter = Long.parseLong((untreatedResponse.split(","))[0].trim());
        this.prologResponse = (untreatedResponse.split(","))[1].trim();
    }
    
}
